# -*- coding: utf-8 -*-

import datetime
import time
from .utils import AgeDeltas
from .constants import AGE_CATEGORIES_FULL
from .index import get_queue_index
from .index.queue import get_queue_index_collection


def f(unit):

    t = time.time()
    for age in AGE_CATEGORIES_FULL.values():
        _ = get_queue_index(index_number="7.4", unit=unit, age_range=age)
    print time.time() - t


def g(unit):

    t = time.time()
    qs = get_queue_index_collection(index_number='7.4', unit=unit)
    for age in AGE_CATEGORIES_FULL.values():
        down, up = AgeDeltas.get_category_deltas(
            age, datetime.date.today)
        filter_ = lambda rec: rec["children__date_of_birth"] > down
        if up:
            filter_ = lambda rec: (
                rec["children__date_of_birth"] > down and
                rec["children__date_of_birth"] < up)
        _ = len([
            filter_(declaration)
            for declaration in qs
        ])
    print time.time() - t
